#!/usr/bin/env python
from numpy import *
from scipy.special import airy
from scipy.optimize import fsolve
from matplotlib.pyplot import *


# Anfangswerte
iv = array([ 0.35502805388781723926,
            -0.25881940379280679841])

# Exakte Loesung
exact = lambda t: row_stack(airy(t)[:2])

# Endzeit
T = -40.0


###################
#  Teilaufgabe 1  #
###################

# TODO: Implement Airy equation right hand side
rhs = lambda t, y : 0.0


####################
#  Teilaufgabe 2   #
####################

def integrate_EE(y0, tstart, tend, N):
    r"""Integrate ODE with explicit Euler method

    Input: y0     ... initial condition
           tstart ... start t
           tend   ... end   t
           N      ... number of steps

    Output: t ... variable
            y ... solution
    """
    y = zeros((2,N+1))
    t = zeros((N+1,))
    t[0] = tstart
    y[:,0] = y0
    h = (tend - tstart) / float(N)

    for n in range(N):
        #
        # TODO: Implement step
        #
        pass

    return t, y


def integrate_IE(y0, tstart, tend, N):
    r"""Integrate ODE with implicit Euler method

    Input: y0     ... initial condition
           tstart ... start t
           tend   ... end   t
           N      ... number of steps

    Output: t ... variable
            y ... solution
    """
    y = zeros((2,N+1))
    t = zeros((N+1,))
    t[0] = tstart
    y[:,0] = y0
    h = (tend - tstart) / float(N)

    for n in range(N):
        #
        # TODO: Implement step
        #
        pass

    return t, y


def integrate_EM(y0, tstart, tend, N):
    r"""Integrate ODE with explicit midpoint method

    Input: y0     ... initial condition
           tstart ... start t
           tend   ... end   t
           N      ... number of steps

    Output: t ... variable
            y ... solution
    """
    y = zeros((2,N+1))
    t = zeros((N+1,))
    t[0] = tstart
    y[:,0] = y0
    h = (tend - tstart) / float(N)

    for n in range(N):
        #
        # TODO: Implement step
        #
        pass

    return t, y


def integrate_IM(y0, tstart, tend, N):
    r"""Integrate ODE with implicit midpoint method

    Input: y0     ... initial condition
           tstart ... start t
           tend   ... end   t
           N      ... number of steps

    Output: t ... variable
            y ... solution
    """
    y = zeros((2,N+1))
    t = zeros((N+1,))
    t[0] = tstart
    y[:,0] = y0
    h = (tend - tstart) / float(N)

    for n in range(N):
        #
        # TODO: Implement step
        #
        pass

    return t, y


N = 10**3
t, y = integrate_EE(iv, 0.0, T, N)
figure()
plot(t, exact(t)[0], "r")
plot(t, y[0,:], "b")
#plot(t, y[1,:], "g")
grid(True)
xlabel("t")
ylabel("Ai(t)")
savefig("img/ai_expl_euler.png")

t, y = integrate_IE(iv, 0.0, T, N)
figure()
plot(t, exact(t)[0], "r")
plot(t, y[0,:], "b")
#plot(t, y[1,:], "g")
grid(True)
xlabel("t")
ylabel("Ai(t)")
savefig("img/ai_impl_euler.png")

t, y = integrate_EM(iv, 0.0, T, N)
figure()
plot(t, exact(t)[0], "r")
plot(t, y[0,:], "b")
#plot(t, y[1,:], "g")
grid(True)
xlabel("t")
ylabel("Ai(t)")
savefig("img/ai_expl_midpoint.png")

t, y = integrate_IM(iv, 0.0, T, N)
figure()
plot(t, exact(t)[0], "r")
plot(t, y[0,:], "b")
#plot(t, y[1,:], "g")
grid(True)
xlabel("t")
ylabel("Ai(t)")
savefig("img/ai_impl_midpoint.png")


####################
#  Teilaufgabe 3   #
####################

def RK_step(B, t, y, h):
    r"""
    Makes a single Runge-Kutta step of size h.

    B: Butcher Schema
    t: Current time t_i
    y: Current solution y_i
    h: Timestep size
    """
    tnew = t
    ynew = y
    s = B.shape[0] - 1
    b = B[s][1:]
    c = B[:,0][:-1]
    A = B[:-1,1:]
    k = zeros((2, s))

    #
    # TODO: Implement a generic Runge Kutta step
    # with Butcher scheme
    #        c|A
    #          -
    #          b
    #

    return tnew, ynew


def RK(B, y0, tstart, tend, N):
    r"""
    Integrate the equation with a Runge-Kutta rule.

    Input: B      ... Butcher Schema
           y0     ... initial condition
           tstart ... start t
           tend   ... end   t
           N      ... number of steps

    Output: t ... variable
            y ... solution
    """
    y = zeros((2,N+1))
    t = zeros((N+1,))
    t[0] = tstart
    y[:,0] = y0
    h = (tend - tstart) / float(N)
    for n in range(N):
        #
        # TODO: fill t, y using RK_step
        #
        pass

    return t, y

# TODO: fill B as Butcher scheme for explicit Euler, check `RK_step` for format
# information.
B = array([[ 42.0 ]])

t, y = RK(B, iv, 0.0, T, N)
figure()
plot(t, exact(t)[0], "r")
plot(t, y[0,:], "b")
#plot(t, y[1,:], "g")
grid(True)
xlabel("t")
ylabel("Ai(t)")
savefig("img/ai_RK_expl_Euler.png")

# TODO: fill B as Butcher scheme for implicit Euler
B = array([[ 42.0 ]])

t, y = RK(B, iv, 0.0, T, N)
figure()
plot(t, exact(t)[0], "r")
plot(t, y[0,:], "b")
#plot(t, y[1,:], "g")
grid(True)
xlabel("t")
ylabel("Ai(t)")
savefig("img/ai_RK_impl_Euler.png")

# TODO: fill B as Butcher scheme for explicit midpoint
B = array([[ 42.0 ]])

t, y = RK(B, iv, 0.0, T, N)
figure()
plot(t, exact(t)[0], "r")
plot(t, y[0,:], "b")
#plot(t, y[1,:], "g")
grid(True)
xlabel("t")
ylabel("Ai(t)")
savefig("img/ai_RK_expl_midpoint.png")


# TODO: fill B as Butcher scheme for implicit midpoint
B = array([[ 42.0 ]])

t, y = RK(B, iv, 0.0, T, N)
figure()
plot(t, exact(t)[0], "r")
plot(t, y[0,:], "b")
#plot(t, y[1,:], "g")
grid(True)
xlabel("t")
ylabel("Ai(t)")
savefig("img/ai_RK_impl_midpoint.png")


####################
#  Teilaufgabe 4   #
####################

def RK_38(y0, tstart, tend, N):
    r"""
    Integrate the equation with the 3/8 Runge-Kutta rule.

    Input:
           y0     ... initial condition
           tstart ... start t
           tend   ... end   t
           N      ... number of steps

    Output: t ... variable
            y ... solution
    """
    # TODO: fill B as Butcher scheme for Runge-Kutta 3/8
    B = array([[ 42.0 ]])

    return RK(B, y0, tstart, tend, N)



t, y = RK_38(iv, 0.0, T, N)
figure()
plot(t, exact(t)[0], "r")
plot(t, y[0,:], "b")
#plot(t, y[1,:], "g")
grid(True)
xlabel("t")
ylabel("Ai(t)")
savefig("img/ai_RK_38.png")
